#pragma once
#include <vector>
#include <fstream>
#include "Exception.h"
#include <algorithm>
#include <iterator>

void createData(const std::string&);
void createDataContainer(const std::string&);

template <class T>
class Data
{
private:
	T container;
	using type = T::value_type;
public:
	Data() : container() {}
	Data(int size) : container(size) {}

	T& loadData(const std::string& filepath) //
	{
		std::ifstream file(filepath);
		if (!file)
		{
			throw FileNotFoundException();
		}
		type data;
		while (!file.eof())
		{
			file >> data;
			container.push_back(data);
		}
		return container;
	}

	T& streamLoadData(const std::string& filepath) //
	{
		std::ifstream file(filepath);
		std::copy(std::istream_iterator<type>(file), std::istream_iterator<type>(), std::back_inserter(container));
		return container;
	}

	void modify()
	{
		type max = type();
		for (auto i = container.begin(); i != container.end(); ++i)
		{
			if (*i > max)
			{
				max = *i;
			}
		}
		for (auto i = container.begin(); i != container.end(); ++i)
		{
			*i /= (max / 2);
		}
	}

	static void modify_iter(T::iterator pos1, T::iterator pos2)
	{
		type max = type();
		for (auto i = pos1; i != pos2; ++i)
		{
			if (*i > max)
			{
				max = *i;
			}
		}
		for (auto i = pos1; i != pos2; ++i)
		{
			*i /= (max / 2);
		}
	}

	void modify_iter() 
	{
		Data::modify_iter(container.begin(), container.end());
	}

	void modify_for_each() 
	{
		type max = type();
		for (auto i = container.begin(); i != container.end(); ++i)
		{
			if (*i > max)
			{
				max = *i;
			}
		}
		std::for_each(container.begin(), container.end(), [max](type& elem) {elem /= (max / 2); });
	}

	void outputResult(const std::string& filepath) 
	{
		std::ofstream file(filepath);
		if (!file)
		{
			throw FileNotFoundException();
		}
		for (auto i = container.begin(); i != container.end(); ++i)
		{
			file << *i << " ";
		}
	}

	void outputResultContainer(const std::string& filepath) 
	{
		std::ofstream file(filepath);
		if (!file)
		{
			throw FileNotFoundException();
		}
		std::copy(container.begin(), container.end(), std::ostream_iterator<type>(file, " "));
	}
};