#include "SportsComplex.h"

bool SportsComplex::operator == (const SportsComplex& info) 
{
	if (container.size() != info.container.size())
	{
		return false;
	}
	auto beg1 = container.begin();
	auto beg2 = info.container.begin();
	while (beg1 != container.end() && beg2 != info.container.end()) 
	{
		SportsComplex::Info inf1 = *beg1;
		SportsComplex::Info inf2 = *beg2;
		if (inf1 != inf2)
		{
			return false;
		}
		++beg1;
		++beg2;
	}
	return true;
}

std::istream& operator >> (std::istream& in, SportsComplex& info) {
	info = SportsComplex();
	while (true) 
	{
		SportsComplex::Info inf;
		in >> inf.client_surname;
		if (inf.client_surname[0] == '0' || inf == SportsComplex::Info()) 
		{
			info.container.insert(SportsComplex::Info());
			break;
		}
		in >> inf.sport_activity; in >> inf.trainer_surname;
		in >> inf.date; in >> inf.time_of_beginning;
		in >> inf.code; in >> inf.minutes; in >> inf.tarif;
		info.container.insert(inf);
	}
	return in;
}

std::ostream& operator << (std::ostream& out, const SportsComplex& info)
{
	for (auto i = info.container.begin(); i != info.container.end(); ++i) 
	{
		out << std::endl << std::setw(4) << i->client_surname << "|" <<
			std::setw(4) << i->sport_activity << "|" <<
			std::setw(4) << i->trainer_surname << "|" <<
			std::setw(4) << i->date << "|" <<
			std::setw(4) << i->time_of_beginning << "|" <<
			std::setw(4) << i->code << "|" <<
			std::setw(4) << i->minutes << "|" <<
			std::setw(4) << i->tarif << "|" << std::endl;
	}
	return out;
}

void SportsComplex::write(std::ofstream& file) 
{
	for (auto i = container.begin(); i != container.end(); ++i) 
	{
		file.write(reinterpret_cast<const char*>(&*i), sizeof(Info));
	}
}

void SportsComplex::read(std::ifstream& file) 
{
	while (!file.eof()) 
	{
		SportsComplex::Info inf;
		file.read(reinterpret_cast<char*>(&inf), sizeof(inf));
		container.insert(inf);
	}
}

void SportsComplex::create(std::ofstream& file) 
{
	SportsComplex info;
	std::cin >> info;
	info.write(file);
}

void SportsComplex::delete_(std::ofstream& write_, std::ifstream& read_) 
{
	bool key = true;
	SportsComplex info;
	info.read(read_);
	for (auto i = info.container.begin(); i != info.container.end(); ++i) 
	{
		if (key && !const_cast<Info&>(*i).is_inside(this->container))
		{
			info.write(write_);
		}
		else
		{
			key = false;
		}
		if (!key)
		{
			info.write(write_);
		}
	}
}

void SportsComplex::replace(std::ofstream& write_, std::ifstream& read_, SportsComplex& info) 
{
	delete_(write_, read_); 
	info.write(write_);
}

void SportsComplex::to_txt(std::ofstream& write_, std::ifstream& read_) 
{
	write_ << "Client's surname" << std::setw(4) << "|" << "Sport activity|" << std::setw(4) <<
		"Trainer's surname" << std::setw(4) << "|" << "Date" << std::setw(4) << "|" <<
		"Time of beginning" << std::setw(4) << "|" << "Code" << std::setw(4) << "|" <<
		"Minutes" << std::setw(4) << "|" << "Tarif" << std::setw(4) << "|" << std::endl;
	
	while (!read_.eof()) 
	{
		SportsComplex info;
		info.read(read_);
		write_ << info;
	}
}