#include <iostream>
#include "Data.h"
#include "SportsComplex.h"

void data_test() 
{
	std::cout << "------------------------------Data Test------------------------------" << std::endl;
	bool key = true;
	while (key) 
	{
		std::cout << "1: Create Data;\n2: Create Data Container;\n3: Load Data;\n4: Stream Load Data;\n" <<
	    "5: Modify;\n6: Modify Iterator;\n7: Modify For Each\n8: Output Result;\n9: Output Result Container;\n"
	    <<"10: Exit;\n";
		int num;
		std::cout << "Choose the operation: ";
		std::cin >> num;
		Data<std::vector<int>> container;
		auto print = [](const std::vector<int>& cont) 
		{               
			for (auto i = cont.begin(); i != cont.end(); ++i) 
			{
				std::cout << *i << " ";
			}
			std::cout << std::endl;
		};
		try 
		{
			switch (num) 
			{
			case 1: createData("file1.txt"); break;
			case 2: createDataContainer("file1.txt"); break;
			case 3: print(container.loadData("file1.txt")); break;
			case 4: print(container.streamLoadData("file1.txt")); break;
			case 5: container.modify(); break;
			case 6: container.modify_iter(); break;
			case 7: container.modify_for_each(); break;
			case 8: container.outputResult("file2.txt"); break;
			case 9: container.outputResultContainer("file2.txt"); break;
			case 10: key = false; break;
			default: std::cout << "No such operation!" << std::endl;
			}
		}
		catch (std::exception& error) 
		{
			std::cerr << error.what() << std::endl;
		}
	}
}

void sports_complex_test() 
{
	std::cout << std::endl << "------------------------------SportsComplex Test------------------------------" << std::endl;
	bool key = true;
	std::ofstream write_1("file1.bin", std::ios::binary);
	std::ifstream read_1("file1.bin", std::ios::binary);   
	std::ofstream write_2("file2.bin", std::ios::binary); 
	std::ofstream write_3("file3.txt");
	SportsComplex info;
	std::cout << "Enter information" << std::endl;
	std::cin >> info;
	while (key) 
	{
		std::cout << std::endl << "1: Create File;\n2: Write;\n3: Delete;\n4: Replace;\n"<<
		"5: To txt;\n6: Exit;" << std::endl;
		int num;
		std::cout << "Choose the operation: ";
		std::cin >> num;
		switch (num) 
		{
		case 1: SportsComplex::create(write_1); break;
		case 2: info.write(write_1); break;
		case 3: info.delete_(write_2, read_1); break;
		case 4: info.replace(write_2, read_1, info); break;
		case 5: SportsComplex::to_txt(write_3, read_1); break;
		case 6: key = false; break;
		default: std::cout << "No such Operation!" << std::endl;
		}
	}
}

int main() 
{
	data_test();
	system("pause");
	sports_complex_test();
	system("pause");
	return 0;
}
